package net.java.dev.mocksgs;

import com.sun.sgs.internal.ManagerLocator;
import java.util.HashMap;
import java.util.Map;

public class MockManagerLocator implements ManagerLocator {

    private MockDataManager dataManager = new MockDataManager();
    private MockChannelManager channelManager = new MockChannelManager();
    private MockTaskManager taskManager = new MockTaskManager();
    private Map<Class, Object> managers = new HashMap<Class, Object>();

    @Override
    public MockChannelManager getChannelManager() {
        return channelManager;
    }

    @Override
    public MockDataManager getDataManager() {
        return dataManager;
    }

    @Override
    public MockTaskManager getTaskManager() {
        return taskManager;
    }

    @Override
    public <T> T getManager(final Class<T> clazz) {
        for (Class key : managers.keySet()) {
            if (clazz.isAssignableFrom(key)) {
                return (T) managers.get(key);
            }
        }
        throw new IllegalArgumentException("MockManager not registered : " +
                                           clazz.getCanonicalName());
    }

    public void addMockManager(final Object manager) {
        managers.put(manager.getClass(), manager);
    }
}
